/*                               -*- Mode: C -*- 
 * c++_c.h --- some macros to help using both c++ and c
 * Author          : Nicolas Anquetil
 * Created On      : Wed Jan 22 11:26:02 1997
 */

/* This file must be readable by C, beware to the comments */

# ifndef CPP_C_H
# define CPP_C_H

# ifdef __cplusplus
# define EXTERNC extern "C"
# else   /* #ifdef __cplusplus */
# define EXTERNC

/* for C, declare all classes pointers to anonymous (void) pointers
 * eg: (SourceFile *) will become (void *).
 * BEWARE: It only works for pointers to classes, but anyway, one
 * should probably not handle actual objects (not pointers) in C */
# define SoftwareObject         void
# define SourceUnit             void
# define SourceFile             void
# define SourceWithinFile       void
# define RoutineSource          void
# define SourceBlock            void
# define ReferenceExistence     void
# define CommentTermExistence   void
# define CompoundTermExistence  void
# define SpecialCodeExistence   void
# define FileInclusionExistence void
# define DataUseExistence       void
# define CompoundDataExistence  void
# define ManifestConstExistence void
# define TypeUseExistence       void
# define RoutineCallExistence   void
# define Definition             void
# define TypedDefinition        void
# define StandaloneDefinition   void
# define Field                  void
# define TypeDef                void
# define DatumDef               void
# define EnumerationConst       void
# define EnumeratedTypeDef      void
# define RecordTypeDef          void


# ifndef FALSE
# define TRUE (1==1)
# define true TRUE
# define FALSE (1==0)
# define false FALSE

typedef int bool;
# endif   /* #ifndef FALSE */

# ifndef NEW
# define NEW(t) (t *)malloc(sizeof(t))
# endif   /* #ifndef NEW */

# endif   /* #ifdef __cplusplus ... else */

# include "cdbClasses.h"

# endif
