//                              -*- Mode: C++ -*-
// testiter.cc --- testing the iterators
// Author          : Nicolas Anquetil
// Created On      : Tue Jan 21 14:57:36 1997
// Last Modified By: Nicolas Anquetil
// Last Modified On: Thu Aug 21 10:24:07 1997
//


# include "testiter.hh"


void main(int argc, char *argv[])
//--------------------------------------------------
{
  SourceFile *file1, *file2;
  RewindIterator<FileInclusionExistence*> *iter1;

  init_pointers();

# ifdef DEBUG
  printf("---------- avant creations fichiers\n");
# endif
  file1 = cdbCreateSourceFile( "f01", 0,"~/KBRE", 1, 101);
  file2 = cdbCreateSourceFile( "f02", 0,"~/KBRE", 2, 102);

# ifdef DEBUG
  printf("---------- avant inclusions\n");
# endif
  cdbRegisterFileInclusion( file1, "f3");
  cdbRegisterFileInclusion( file1, "f5");
  cdbRegisterFileInclusion( file1, "f1");
  cdbRegisterFileInclusion( file1, "f9");
  cdbRegisterFileInclusion( file1, "f2");
  cdbRegisterFileInclusion( file1, "f7");

  printf("---------- file1 ... [f1,f2,f3,f5,f7,f9]\n");
  // --------------------------------------------------
  iter1 = new RewindIterator<FileInclusionExistence*>(
            new ListIterator<FileInclusionExistence*>(
			  file1->includes()));

  while (! iter1->eoi())
	printf("included file name:%s\n", cdbGetObjectName(iter1->next()));

  printf("There are %d elements in the list\n", iter1->howManyLeft());
  iter1->rewind();
  printf("There are %d elements in the list\n", iter1->howManyLeft());

  while (! iter1->eoi())
	printf("included file name:%s\n", cdbGetObjectName(iter1->next()));

  delete( iter1);
}
