//                              -*- Mode: C++ -*- 
// utils.hh --- utilities for using the new DB
// Author          : Nicolas Anquetil
// Created On      : Fri Dec 13 17:50:43 1996
// 


# ifndef UTILS_H
# define UTILS_H

# include "cdbFileMem.hh"   // needed by container.hh
# include "container.hh"
# include "newDB.hh"


// a small initialization function to set the global pointers right
extern "C" void init_pointers();
extern "C" void init_pointers_from_db();


// get a `SoftwareObject' named `name' if one exist
VoidIterator<SoftwareObject*> *getNamedObject(char *name,
											  class_t filter);

// For sorted Iterators, comparing and merging 2 SoftwareObjects
int             SO_strict_cmp(SoftwareObject*, SoftwareObject*);
int             SO_loose_cmp(SoftwareObject*, SoftwareObject*);
SoftwareObject *SOmerge(SoftwareObject*, SoftwareObject*);
void            sortTheList( List<SoftwareObject*> *);


template<class T>
void
addInSet(List<T*> *set, T *so)
// --------------------------------------------------
// add `so' in `set' if not already present
// so is a software object
{
  LIterator<T*> *iter;
  bool found;

  found = false;
  iter = new LIterator<T*>(set);
  while ( (! found) && (! iter->eoi()) )
	found = (so == iter->next());

  delete( iter);

  if (! found)
	set->add(so);
}

#endif



